
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Invoice_linesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const invoice_lines = await db.invoice_lines.create(
            {
                id: data.id || undefined,
        
        type: data.type
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        quantity: data.quantity
        ||
        null
            ,
            
        unit_price: data.unit_price
        ||
        null
            ,
            
        amount: data.amount
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await invoice_lines.setInvoice( data.invoice || null, {
            transaction,
        });
        
        await invoice_lines.setTrip( data.trip || null, {
            transaction,
        });
        
        await invoice_lines.setLoad( data.load || null, {
            transaction,
        });
        
        await invoice_lines.setCost_item( data.cost_item || null, {
            transaction,
        });
        

        

        

        return invoice_lines;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const invoice_linesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                type: item.type
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                quantity: item.quantity
            ||
            null
            ,
            
                unit_price: item.unit_price
            ||
            null
            ,
            
                amount: item.amount
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const invoice_lines = await db.invoice_lines.bulkCreate(invoice_linesData, { transaction });

        // For each item created, replace relation files
        

        return invoice_lines;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const invoice_lines = await db.invoice_lines.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.type !== undefined) updatePayload.type = data.type;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.quantity !== undefined) updatePayload.quantity = data.quantity;
        
        
        if (data.unit_price !== undefined) updatePayload.unit_price = data.unit_price;
        
        
        if (data.amount !== undefined) updatePayload.amount = data.amount;
        
        
        updatePayload.updatedById = currentUser.id;

        await invoice_lines.update(updatePayload, {transaction});

        
        
        if (data.invoice !== undefined) {
            await invoice_lines.setInvoice(
              
              data.invoice,
              
              { transaction }
            );
        }
        
        if (data.trip !== undefined) {
            await invoice_lines.setTrip(
              
              data.trip,
              
              { transaction }
            );
        }
        
        if (data.load !== undefined) {
            await invoice_lines.setLoad(
              
              data.load,
              
              { transaction }
            );
        }
        
        if (data.cost_item !== undefined) {
            await invoice_lines.setCost_item(
              
              data.cost_item,
              
              { transaction }
            );
        }
        

        
        

        

        return invoice_lines;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const invoice_lines = await db.invoice_lines.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of invoice_lines) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of invoice_lines) {
                await record.destroy({transaction});
            }
        });


        return invoice_lines;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const invoice_lines = await db.invoice_lines.findByPk(id, options);

        await invoice_lines.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await invoice_lines.destroy({
            transaction
        });

        return invoice_lines;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const invoice_lines = await db.invoice_lines.findOne(
            { where },
            { transaction },
        );

        if (!invoice_lines) {
            return invoice_lines;
        }

        const output = invoice_lines.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.invoice = await invoice_lines.getInvoice({
            transaction
        });
        
        
        output.trip = await invoice_lines.getTrip({
            transaction
        });
        
        
        output.load = await invoice_lines.getLoad({
            transaction
        });
        
        
        output.cost_item = await invoice_lines.getCost_item({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.invoices,
        as: 'invoice',
        
        where: filter.invoice ? {
          [Op.or]: [
            { id: { [Op.in]: filter.invoice.split('|').map(term => Utils.uuid(term)) } },
            {
              invoice_no: {
                [Op.or]: filter.invoice.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.trips,
        as: 'trip',
        
        where: filter.trip ? {
          [Op.or]: [
            { id: { [Op.in]: filter.trip.split('|').map(term => Utils.uuid(term)) } },
            {
              trip_no: {
                [Op.or]: filter.trip.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.loads,
        as: 'load',
        
        where: filter.load ? {
          [Op.or]: [
            { id: { [Op.in]: filter.load.split('|').map(term => Utils.uuid(term)) } },
            {
              load_no: {
                [Op.or]: filter.load.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.cost_items,
        as: 'cost_item',
        
        where: filter.cost_item ? {
          [Op.or]: [
            { id: { [Op.in]: filter.cost_item.split('|').map(term => Utils.uuid(term)) } },
            {
              reference: {
                [Op.or]: filter.cost_item.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'invoice_lines',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.quantityRange) {
                const [start, end] = filter.quantityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity: {
                    ...where.quantity,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity: {
                    ...where.quantity,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.unit_priceRange) {
                const [start, end] = filter.unit_priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    unit_price: {
                    ...where.unit_price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    unit_price: {
                    ...where.unit_price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.amountRange) {
                const [start, end] = filter.amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.type) {
                where = {
                    ...where,
                type: filter.type,
            };
            }
            


      

      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.invoice_lines.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'invoice_lines',
                        'description',
                        query,
                    ),
                ],
            };
        }

        const records = await db.invoice_lines.findAll({
            attributes: [ 'id', 'description' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['description', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.description,
        }));
    }

    
};

